<?php
if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }
	
	$opt = cmsCore::request('opt', 'str', 'config');
	$id  = cmsCore::request('id', 'int');

	cpAddPathway('SMS сообщения', '?view=components&do=config&id='.$_REQUEST['id']);
	
	echo '<h3>SMS сообщения</h3>';
	
	
	$cfg = $inCore->loadComponentConfig('smssend');

	if($opt=='saveconfig'){	

        if (!cmsCore::validateForm()) { cmsCore::error404(); }

		$cfg = array();
		$cfg['api']  = cmsCore::request('api', 'str');
		$cfg['project'] = cmsCore::request('project', 'str');
        $cfg['testmode'] = cmsCore::request('testmode', 'int');	
        $cfg['price'] = cmsCore::request('price', 'int');
		$cfg['p_price'] = cmsCore::request('p_price', 'int');
        $cfg['sms_price'] = cmsCore::request('sms_price', 'int');	
        $cfg['sms_i'] = cmsCore::request('sms_i', 'int');	
        $cfg['package'] = cmsCore::request('package', 'int');		

		$inCore->saveComponentConfig('smssend', $cfg);
		
		cmsCore::addSessionMessage('Настройки успешно сохранены', 'success');
		cmsCore::redirectBack();

	}
?>	
	
<form action="index.php?view=components&amp;do=config&amp;id=<?php echo $id;?>" method="post" name="optform" target="_self" id="form1">
<input type="hidden" name="csrf_token" value="<?php echo cmsUser::getCsrfToken(); ?>" />
        <table width="650" border="0" cellpadding="10" cellspacing="0" class="proptable">
          <tr>
            <td colspan="2" bgcolor="#EBEBEB"><strong>Основные настройки</strong></td>
          </tr>
          <tr>
            <td>Api key со страницы <a href="http://mainsms.ru/office/api_account">http://mainsms.ru/office/api_account</a></td>
            <td valign="top"><input name="api" type="text" id="api" size="45" value="<?php echo $cfg['api'];?>"/></td>
          </tr>
		  <tr>
            <td>Название проекта со страницы <a href="http://mainsms.ru/office/api_account">http://mainsms.ru/office/api_account</a></td>
            <td valign="top"><input name="project" type="text" id="project" size="45" value="<?php echo $cfg['project'];?>"/></td>
          </tr>
		  <tr>
            <td>Включить тестовый режим (сообщения в этом режиме не отправляются)</td>
            <td width="300" valign="top">
            <label><input name="testmode" type="radio" value="1" <?php if ($cfg['testmode']) { echo 'checked="checked"'; } ?>/> Да</label>
            <label><input name="testmode" type="radio" value="0" <?php if (!$cfg['testmode']) { echo 'checked="checked"'; } ?>/> Нет</label>
            </td>
          </tr>
		  <tr>
            <td>Как продавать смс-сообщения?</td>
            <td width="300" valign="top">
            <label><input name="sms_price" type="radio" value="1" <?php if ($cfg['sms_price']) { echo 'checked="checked"'; } ?>/> В баллах</label>
            <label><input name="sms_price" type="radio" value="0" <?php if (!$cfg['sms_price']) { echo 'checked="checked"'; } ?>/> Пакетами</label>
            </td>
          </tr>
		  <tr>
            <td>Стоимость одного смс-сообщения (в баллах)</td>
            <td valign="top"><input name="price" type="text" id="price" size="6" value="<?php echo $cfg['price'];?>"/></td>
          </tr>
		   <tr>
            <td>Стоимость одного ПАКЕТА смс-сообщений (в баллах)</td>
            <td valign="top"><input name="p_price" type="text" id="p_price" size="6" value="<?php echo $cfg['p_price'];?>"/></td>
          </tr>
		  <tr>
            <td>Число смс в одном пакете</td>
            <td valign="top"><input name="package" type="text" id="package" size="6" value="<?php echo $cfg['package'];?>"/>Шт.</td>
          </tr>
		</table>
		<p>
          <input name="opt" type="hidden" value="saveconfig" />
          <input name="save" type="submit" id="save" value="Сохранить" />
          <input name="back" type="button" id="back" value="Отмена" onclick="window.location.href='index.php?view=components';"/>
        </p>
</form>