<?php
function smssend(){

    $inCore = cmsCore::getInstance();
    $inPage = cmsPage::getInstance();
    $inUser = cmsUser::getInstance();
	$inConf = cmsConfig::getInstance();
	
	define('IS_BILLING', $inCore->isComponentInstalled('billing'));
    if (IS_BILLING) { $inCore->loadClass('billing'); }

	$cfg = $inCore->loadComponentConfig('smssend');

	if(!$cfg['component_enabled']) { cmsCore::error404(); }
 
    $inCore->loadModel('smssend'); 
   
    $user_id    = $inUser->id;
	
	if ($user_id == '0') { echo "Доступ к данному разделу возможен только зарегистрированному пользователю"; } 
	else {
	
	/* 
  создаём экземпляр класса 

  Список параметров ($project, $key, $useSSL = false, $testMode = false)
  $project - название проекта, берется со страницы http://mainsms.ru/office/api_account
  $key - ключ проекта, берется со страницы http://mainsms.ru/office/api_account
  $useSSL - не обязательный параметр, если true то взаимодействие будет осуществляться по протоколу https иначе http
  $testMode - не обязательный параметр, если true то сообщения не будут отправляться и деньги не будут списываться(используется для отладки)

  $api = new MainSMS('instest', '776514ea84a4f', false, false);
  */
	
	if ($cfg['testmode'] == "0") {
	    $cfg['testmode'] = false;
	} else {
	    $cfg['testmode'] = true;
	}
	
	session_start();
    $api = new cms_model_smssend($cfg['project'], $cfg['api'], false, $cfg['testmode']); 
	
	$balsms = $api->getSmsBalance();
	
	$do = $inCore->request('do', 'str', 'send');
	
	
if ($do == 'send') {

/* ==================================================================================================== */
/* ==================================================================================================== */
    // Проверка статуса сообщения 
        if(isset($_REQUEST['status'])) {
            if(isset($_SESSION['sms'][$_REQUEST['status']])) {


            $sms = $_SESSION['sms'][$_REQUEST['status']];
            $status = $api->checkStatus($sms['response']['messages_id']);
			print_r($status);
                foreach($status as $st_mes){
				    $st_mes = $st_mes;
				}
				foreach($sms['response']['messages_id'] as $sms_id){
		            $sms_id = $sms_id;
		        }

     			    $res_status = $_REQUEST['status'];
			        $res_date = date('H:i:s',$sms['time']); 
			        $res_sender = $sms['sender'];
					$res_text = $sms['text'];

              } 
            } 
    //заносим результат в базу
        $add_sms = $api->addStatus($sms_id, $st_mes);


/* ==================================================================================================== */
/* ==================================================================================================== */

//если на смс балансе есть смски, то после отправки списываем с баланса смс

if(isset($_REQUEST['clear'])){
  unset($_SESSION['sms'] );
}

// Post отправка смс
if(isset($_POST['send'])) { 
  if(!empty($_POST['sender']) && !empty($_POST['recipients']) && !empty($_POST['text'])){
  
    $text = cmsCore::request('text');
            $text = cmsCore::request('text');
            if (preg_match( '~[а-яА-ЯЁё]~', $text)) {
                $text = mb_strlen($text) <= 70 ? 1 : ceil(mb_strlen($text)/67);
            }
            else {
                $text = mb_strlen($text) <= 160 ? 1 : ceil(mb_strlen($text)/153);
            }
   
	
  
    if($inUser->sms_balance > "0") {
	    if($inUser->sms_balance >= $text) {
	
    // Отправляем сообщение
    $api->sendSMS($_POST['recipients'], $_POST['text'], $_POST['sender']);
			
	        $user_id    = $inUser->id;
	        $sender     = $_POST['sender'];
            $recipients = $_POST['recipients'];
			$text       = $_POST['text'];
  

    
$response = $api->getResponse();
 $_SESSION['sms'][] = Array( 
      "response" => $response, 
      "text"=>$_POST['text'], 
      "sender"=>$_POST['sender'], 
      "time"=>time(), 
    );
		
	foreach($response['messages_id'] as $sms_id) {
	    $sms_id = $sms_id ;
	}
	
	$parts = $response['parts'];
	$true_price = $response['price']; 
	$price = $cfg['price']*$parts;

	
//заносим в бд по отдельности каждое сообщение, если получателей несколько
	if (preg_match( '~[,]~', $recipients)) { 

	    for($i = 0, $size = count($response['recipients']); $i < $size; $i++) {
		   $recipients = $response['recipients'][$i];
		   $sms_id = $response['messages_id'][$i];
		   $true_price = str_replace(',', '.', $response['price']) / $size;
		   
		   $ID_message = $api->addSmstext($user_id, $sms_id, $sender, $recipients, $text, $true_price, $parts, $price);
		}
        $parts = $parts*$size;
	
        $upd_sb = $api->updateSB($user_id, $parts);		

//заносим в бд, если получатель один
	} else {
	
	    $ID_message = $api->addSmstext($user_id, $sms_id, $sender, $recipients, $text, $true_price, $parts, $price);
	    
		$upd_sb = $api->updateSB($user_id, $parts);	
	}

	
	        if ($ID_message){
                cmsCore::addSessionMessage('Сообщение успешно добавлено в обработку!', 'success');
            }

            if (!$ID_message){
                cmsCore::addSessionMessage('Ошибка добавления сообщения в обработку!', 'error');
            }
	            
  

    } else { echo "Недостаточно смс для отправки сообщения"; }
	
} elseif($inUser->balance > "0") {
    if($inUser->balance >= $cfg['price']*$text) {

//если нет, то списываем с баланса биллинга    
	
    // Отправляем сообщение
    $api->sendSMS($_POST['recipients'], $_POST['text'], $_POST['sender']);
			
	        $user_id    = $inUser->id;
	        $sender     = $_POST['sender'];
            $recipients = $_POST['recipients'];
			$text       = $_POST['text'];
  

    
$response = $api->getResponse();
 $_SESSION['sms'][] = Array( 
      "response" => $response, 
      "text"=>$_POST['text'], 
      "sender"=>$_POST['sender'], 
      "time"=>time(), 
    );
	
	foreach($response['messages_id'] as $sms_id) {
	    $sms_id = $sms_id ;
	}
	
	$parts = $response['parts'];
	$true_price = $response['price']; 
	 
	
	$price = $cfg['price']*$parts;
//заносим в бд по отдельности каждое сообщение, если получателей несколько
    if (preg_match( '~[,]~', $recipients)) { 

	    for($i = 0, $size = count($response['recipients']); $i < $size; $i++) {
		   $recipients = $response['recipients'][$i];
		   $sms_id = $response['messages_id'][$i];
		   $true_price = str_replace(',', '.', $response['price']) / $size;
		   
		   $ID_message = $api->addSmstext($user_id, $sms_id, $sender, $recipients, $text, $true_price, $parts, $price);
		}
		
        $price = $cfg['price']*$parts*$size;
	
        $UP_balance = $api->updateBalance($user_id, $price);
		
	} else {

    $UP_balance = $api->updateBalance($user_id, $price);
	
	$ID_message = $api->addSmstext($user_id, $sms_id, $sender, $recipients, $text, $true_price, $parts, $price);
	
	}
	
	        if ($ID_message){
                cmsCore::addSessionMessage('Сообщение успешно добавлено в обработку!', 'success');
            }

            if (!$ID_message){
                cmsCore::addSessionMessage('Ошибка добавления сообщения в обработку!', 'error');
            }
	} else { echo "На вашем счете не достаточно средств для отправки смс сообщений"; }           
  }
}
}

/* ==================== Отправка сообщений =================== */			
        
		 if(isset($_SESSION['sms'])) { 
           if(!empty($_SESSION['sms'])) {  

			$sms = $_SESSION['sms'];

		   }
         }	 
		

/* ==================================================================================================== */
/* ==================================================================================================== */

//Покупка пакетов

if(isset($_POST['package'])) { 
  if(!empty($_POST['amount'])){
  
    $amount = $_POST['amount'];
	$amount = $amount * $cfg['package'];
	$cost = $cfg['p_price'] * $_POST['amount'];
    
  if($inUser->balance >= $cost) {
	
	$ID_package = $api->addSmsPackage($user_id, $amount, $cost);
	
	$SMS_balance = $api->updateSmsBalance($user_id, $amount);
	
	$UP_balsms = $api->updateBal_sms($user_id, $cost);
	
  }
	
	        if ($ID_package){
                cmsCore::addSessionMessage('Пакет куплен!', 'success');
            }

            if (!$ID_package){
                cmsCore::addSessionMessage('Ошибка покупки пакета! Возможно на Вашем счтете недостаточно средств для покупки.<br/> Пожалуйста пополните счет или попробуйте позже', 'error');
            }


    }       
}


/* ==================================================================================================== */
/* ==================================================================================================== */

//баланс сообщений
        
        $IDuser    = $inUser->id;
		$package = $cfg['package'];  
        $is_admin = $inUser->is_admin;
        $balance = $inUser->balance;
        $inPage->setTitle("Отправка сообщений");
		
		
		

        $smarty = $inCore->initSmarty('components', 'com_smssend_send.tpl');
 
        //5. передаем в шаблон список сообщений и флаг администратора
        $smarty->assign('sms', $sms);
		$smarty->assign('balsms', $balsms);
        $smarty->assign('is_admin', $is_admin);
		$smarty->assign('IDuser', $IDuser);
		$smarty->assign('package', $package);
		$smarty->assign('balance', $balance);
		$smarty->assign('res_status', $res_status);
		$smarty->assign('status', $status);
		$smarty->assign('res_sender', $res_sender);
		$smarty->assign('res_text', $res_text);
		$smarty->assign('res_date', $res_date);
		$smarty->assign('p_price', $cfg['p_price']);
 
        //6. выводим шаблон на экран
        $smarty->display('com_smssend_send.tpl');
		
		//7. завершаем работу компонента
        return;
		
}

/* ==================================================================================================== */
/* ==================================================================================================== */


if ($do == 'history') {

if(isset($_POST['postid'])) { 
  if(!empty($_POST['pid'])){
  
    $pid = $_POST['pid'];
	
	// Проверка статуса сообщения 
			
            $status = $api->checkStatus($pid);
			
			
                foreach($status as $key => $st_mes){
				    $sms_id = $key;
					$st_mes = $st_mes;
				}


     			    $res_status = $_REQUEST['status'];
			        $res_date = date('H:i:s',$sms['time']); 
			        $res_sender = $sms['sender'];
					$res_text = $sms['text'];

        //заносим результат в базу
            $add_sms = $api->addStatus($sms_id, $st_mes);
			
  }
}	

        $sms_mess = $api->getSms();
		
/* ==================================================================================================== */
/* ==================================================================================================== */

//Покупка пакетов

if(isset($_POST['package'])) { 
  if(!empty($_POST['amount'])){
  
    $amount = $_POST['amount'];
	$amount = $amount * $cfg['package'];
	$cost = $cfg['p_price'] * $_POST['amount'];
    
  if($inUser->balance >= $cost) {
	
	$ID_package = $api->addSmsPackage($user_id, $amount, $cost);
	
	$SMS_balance = $api->updateSmsBalance($user_id, $amount);
	
	$UP_balsms = $api->updateBal_sms($user_id, $cost);
	
  }
	
	        if ($ID_package){
                cmsCore::addSessionMessage('Пакет куплен!', 'success');
            }

            if (!$ID_package){
                cmsCore::addSessionMessage('Ошибка покупки пакета! Возможно на Вашем счтете недостаточно средств для покупки.<br/> Пожалуйста пополните счет или попробуйте позже', 'error');
            }


    }       
}


/* ==================================================================================================== */
/* ==================================================================================================== */

//баланс сообщений
        
		$package = $cfg['package'];  
        $is_admin = $inUser->is_admin;
        $IDuser    = $inUser->id;
        $inPage->setTitle("История отправленных сообщений");

        $smarty = $inCore->initSmarty('components', 'com_smssend_history.tpl');

        $smarty->assign('sms_mess', $sms_mess);
        $smarty->assign('is_admin', $is_admin);	
        $smarty->assign('status', $status);		
        $smarty->assign('IDuser', $IDuser);
		$smarty->assign('package', $package);
		$smarty->assign('balsms', $balsms);
        $smarty->display('com_smssend_history.tpl');
		$smarty->assign('p_price', $cfg['p_price']);

        return;
}
}
}
?>
